VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "SString"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' Classe SString
' Auteur : Ludovic (pied-vif@infonie.fr)
' Dfinition d'un ensemble de proprits et de mthodes pour faciliter
' l'utilisation des objets String sous Visual Basic.
Option Explicit
' Dfinition de la variable contenant la chane manipule.
Private mstString As String
Public Enum ssSort
    ssTri_A_Z = 1
    ssTri_Z_A = -1
End Enum
Private Sub Class_Initialize()
' Initialisation de la chane.
mstString = vbNullString
End Sub
Public Property Let Str(ByVal vData As String)
' Affectation de la valeur de la chane.
mstString = vData
End Property
Public Property Get Str() As String
Attribute Str.VB_UserMemId = 0
Attribute Str.VB_MemberFlags = "200"
' Rcupration de la valeur de la chane.
Str = mstString
End Property
Public Function Length() As Long
' Retourne la longueur de la chane.
Length = Len(mstString)
End Function
Public Function Maj() As String
' Passe la chane en majuscule.
Maj = UCase$(mstString)
End Function
Public Function Min() As String
' Passe la chane en minuscule.
Min = LCase$(mstString)
End Function
Public Function NbMot(stSeparateur As String) As Long
' Retourne le nombre de mots de la chane. Le sparateur
' utilis doit tre donn en paramtre.
Dim lgNBMot As Long
Dim lgPos As Long
If stSeparateur <> vbNullString Then
    lgNBMot = 0
    lgPos = 0
    Do
        lgPos = InStr(lgPos + 1, mstString, stSeparateur)
        lgNBMot = lgNBMot + 1
    Loop Until lgPos = 0
    If mstString = vbNullString Then NbMot = 0 Else NbMot = lgNBMot
Else
    NbMot = 0
End If
End Function
Public Property Get TriMot(stCarSep As String, ssTri As ssSort) As SString
' Cette fonction a pour but de trier tous les mots de la chanes.
' Le caractre de sparation des mots est donn en paramtre,
' l'ordre du tri galement.
Dim lgLen As Long
Dim ssTMP As New SString
lgLen = Me.NbMot(stCarSep)
If lgLen = 0 Then
    ssTMP = vbNullString
Else
    ReDim stTMP(lgLen) As String
    Dim i As Long, j As Long
' On stocke tous les mots dans un tableau.
    For i = 1 To lgLen
        stTMP(i) = Me.Mot(i, stCarSep)
    Next i
' On tri le tableau.
    For i = 1 To lgLen - 1
        For j = 1 To lgLen - 1
            If ((ssTri = ssTri_A_Z) And (stTMP(j) > stTMP(j + 1))) Or _
                ((ssTri = ssTri_Z_A) And (stTMP(j) < stTMP(j + 1))) Then
                    stTMP(0) = stTMP(j)
                    stTMP(j) = stTMP(j + 1)
                    stTMP(j + 1) = stTMP(0)
            End If
        Next j
    Next i
' On remet le tableau tri dans une chane.
    ssTMP = stTMP(1)
    For i = 2 To lgLen
        ssTMP = ssTMP & stCarSep & stTMP(i)
    Next i
End If
Set TriMot = ssTMP
End Property
Public Function Remplace(stAvant As String, stApres As String) As SString
' Cette fonction remplace toutes les occurences de la chane stAvant
' par la chane stApres.
Dim lgPos As Long
Dim ssTMP As New SString
Dim stTMP As String
Dim lgRes As Long
Dim stRes() As String
If stAvant <> vbNullString Then
    stTMP = mstString
    lgPos = InStr(stTMP, stAvant)
    lgRes = 0
    Do While lgPos > 0
        ReDim Preserve stRes(lgRes) As String
        stRes(lgRes) = Left$(stTMP, lgPos - 1)
        lgRes = lgRes + 1
        stTMP = Right$(stTMP, Len(stTMP) - lgPos + 1 - Len(stAvant))
        lgPos = InStr(stTMP, stAvant)
    Loop
    ssTMP = vbNullString
    For lgPos = 0 To lgRes - 1
        ssTMP = ssTMP & stRes(lgPos) & stApres
    Next lgPos
    ssTMP = ssTMP & stTMP
Else
    ssTMP = mstString
End If
Set Remplace = ssTMP
End Function
Public Function EnleveMot(stSeparateur As String, lgPosition As Long) As SString
' Cette fonction permet d'enlever un mot de la chane. La particularit par rapport
'  une affectation de chane nulle en utilisant la mthode Mot, est ici, que le
' sparateur est galement supprim.
Dim lgOld As Long
Dim lgPos As Long
Dim lgNb As Long
Dim ssTMP As New SString
' Si on sort des limites de la chane, on retourne une chane vide.
If (lgPosition < 1) Or (Me.NbMot(stSeparateur) < lgPosition) Then
    ssTMP = vbNullString
Else
    lgOld = 0
    lgPos = 0
    lgNb = 0
    Do
' Parcours de tous les mots dlimits par le sparateur.
        If lgOld = 0 Then lgOld = 1 Else lgOld = lgPos + Len(stSeparateur)
        lgPos = InStr(lgOld, mstString, stSeparateur)
        lgNb = lgNb + 1
    Loop Until (lgNb >= lgPosition)
    If lgPos = 0 Then
        lgPos = Len(mstString)
' On diminue lgOld pour supprimer le sparateur de fin de ligne.
        lgOld = lgOld - 1
    End If
' Suppression du mot. On prend le dbut et la fin de la chane sans le mot  enlever.
    ssTMP = Left$(mstString, lgOld - 1) & Right$(mstString, Len(mstString) - lgPos)
End If
Set EnleveMot = ssTMP
End Function
Public Property Get Mot(lgPosition As Long, stSeparateur As String) As SString
' Permet de rcuprer un mot de la chane suivant un sparateur dfini.
' Retourne un objet SString. Si le mot demand n'existe pas, retourne une
' chane vide.
Dim lgOld As Long
Dim lgPos As Long
Dim lgNb As Long
Dim ssTMP As New SString
If (lgPosition < 1) Or (Me.NbMot(stSeparateur) < lgPosition) Then
' Si on sort des limites de la chane, on retourne une chane vide.
    ssTMP = vbNullString
Else
    lgOld = 0
    lgPos = 0
    lgNb = 0
    Do
' Parcours de tous les mots dlimits par le sparateur.
        If lgOld = 0 Then lgOld = 1 Else lgOld = lgPos + Len(stSeparateur)
        lgPos = InStr(lgOld, mstString, stSeparateur)
        lgNb = lgNb + 1
    Loop Until (lgNb >= lgPosition)
    If lgPos = 0 Then lgPos = Len(mstString) + 1
    ssTMP = Mid$(mstString, lgOld, lgPos - lgOld)
End If
Set Mot = ssTMP
End Property
Public Property Let Mot(lgPosition As Long, stSeparateur As String, ByVal vData As Variant)
' Permet d'affecter un nouveau mot  la place d'un ancien.
' Il suffit d'indiquer la position dans la chane, le sparateur  utiliser
' et le nouveau mot  mettre en place.
Dim lgOld As Long
Dim lgPos As Long
Dim lgNb As Long
' Si le vData n'est pas une chane, on sort.
If Not (VarType(vData) <> vbString) Then
' Si on sort des limites de la chane, on retourne une chane vide.
    If Not ((lgPosition < 1) Or (Me.NbMot(stSeparateur) < lgPosition)) Then
        lgOld = 0
        lgPos = 0
        lgNb = 0
        Do
' Parcours de tous les mots dlimits par le sparateur.
            If lgOld = 0 Then lgOld = 1 Else lgOld = lgPos + Len(stSeparateur)
            lgPos = InStr(lgOld, mstString, stSeparateur)
            lgNb = lgNb + 1
        Loop Until (lgNb >= lgPosition)
        If lgPos = 0 Then lgPos = Len(mstString) + 1
' Insertion du nouveau mot  la place de l'ancien.
        mstString = Left$(mstString, lgOld - 1) & vData & Right$(mstString, Len(mstString) - lgPos + 1)
    End If
End If
End Property
Public Function Filtre(stFiltre As String) As SString
' Cette fonction filtre la chane. Tous les caractres qui ne sont pas prsents
' dans stFiltre sont enlevs.
Dim lgPos As Long
Dim lgLen As Long
Dim ssTMP As New SString
If stFiltre <> vbNullString Then
    lgLen = Len(mstString)
    lgPos = 1
    ssTMP = mstString
    Do While lgPos <= lgLen
' Teste si le caractre courant fait partie du filtre.
        If InStr(stFiltre, Mid$(ssTMP, lgPos, 1)) <> 0 Then
            lgPos = lgPos + 1
        Else
' Rduction de la chane.
            ssTMP = Left$(ssTMP, lgPos - 1) & Right$(ssTMP, lgLen - lgPos)
' La longueur est diminue.
            lgLen = lgLen - 1
        End If
    Loop
Else
    ssTMP = vbNullString
End If
Set Filtre = ssTMP
End Function
Public Function Insere(lgPosition As Long, stSeparateur As String, stMot As String) As SString
' Insre un nouveau dans la chane,  la position indique.
' Si la position indique est plus grande que le nombre de mot,
' le mot  insrer est mis  la fin.
' Cette fonction n'est rellement qu' utilis dans le cadre d'une
' insertion  l'intrieure de la chane, pour l'ajout au dbut ou  la
' fin, il est plus rapide de le faire soi-mme.
Dim lgOld As Long
Dim lgPos As Long
Dim lgNb As Long
Dim ssTMP As New SString
If (lgPosition < 1) Then
    ssTMP = vbNullString
ElseIf lgPosition < 2 Then
    ssTMP = stMot & stSeparateur & mstString
ElseIf lgPosition > Me.NbMot(stSeparateur) Then
    ssTMP = mstString & stSeparateur & stMot
Else
        lgOld = 0
        lgPos = 0
        lgNb = 0
        Do
' Parcours de tous les mots dlimits par le sparateur.
            If lgOld = 0 Then lgOld = 1 Else lgOld = lgPos + Len(stSeparateur)
            lgPos = InStr(lgOld, mstString, stSeparateur)
            lgNb = lgNb + 1
        Loop Until (lgNb >= lgPosition)
        If lgPos = 0 Then lgPos = Len(mstString) + 1
' Insertion du nouveau mot  la place de l'ancien.
        ssTMP = Left$(mstString, lgOld - 1) & stMot & stSeparateur & Mid$(mstString, lgOld, Len(mstString) - lgOld + 1)
End If
Set Insere = ssTMP
End Function
